
\begin{code}
module Main (main) where

import Word
import Monad
import Char
import Packet
import Bits
import MD5 (md5i, Str(Str))
import SHA1 (sha1i)
import CAST5 (cast5_enc, FullKey)
import ParsePackets
import System
import Inflate
import IO

main :: IO ()
main = do hSetBuffering stdout NoBuffering
          args <- getArgs
          case args of
              [filename] -> do s <- readFile filename
                               doit s
              _ -> error "Usage: ./Test filename.gpg" -- XXX

doit :: String -> IO ()
doit s
     = do let ps = parse_packets s
          print ps
          case ps of
              [T3_SK_ESK CAST5 (IteratedSaltedS2K hash salt count) Nothing,
               T9_SED sed']
                -> do let sed = map fromIntegral sed'
                      let (raw_key, raw_bits) = make_key hash salt count " "
                          -- is this right in the < case?
                          key = if raw_bits > 128 -- hardcoded for CAST5
                                then shiftR raw_key (raw_bits - 128)
                                else raw_key
                      putStrLn $ "Key = " ++ show key
                      let iv = replicate 8 0
                          iv_enc = cast5_enc key iv
                      putStrLn $ "IV enc = " ++ concatMap show_hex iv_enc
                      putStrLn $ "sed = " ++ show sed
                      let random_data_8 = zipWith xor sed iv_enc
                      putStrLn $ "random_data_8 = " ++ show random_data_8
                      let fr = take 8 sed
                          fre = cast5_enc key fr
                          random_data_2 = [(fre!!0) `xor` (sed !! 8),
                                           (fre!!1) `xor` (sed !! 9)]
                      putStrLn $ "random_data_2 = " ++ show random_data_2
                      when (random_data_2 /= drop 6 random_data_8)
                          $ error "Random bytes 7, 8 /= 9, 10"
                      doit $ map (chr . fromIntegral) $ decrypt key $ drop 2 sed
              [T8_CD ZIP is] -> case inflate is of
                                    (xs, rest) -> do unless (rest == []) $ putStrLn $ "Remaining bits: " ++ show rest
                                                     doit $ map (chr . fromIntegral) xs
              [T11_LD Binary filename _ content] ->
                  do putStrLn $ "Write data to " ++ filename ++ "? [Yn]"
                     yes_or_no <- getLine
                     if null yes_or_no || toLower (head yes_or_no) == 'y'
                         then writeFile filename content
                         else return ()
              _ -> putStrLn "Not doing anything"

decrypt :: FullKey -> [Word8] -> [Word8]
decrypt _ [] = []
decrypt k xs = let fre = cast5_enc k this
                   next_8_enc = take 8 rest
                   next_8_enc' = zipWith xor fre next_8_enc
               in next_8_enc' ++ decrypt k rest
    where (this, rest) = splitAt 8 xs

show_hex :: Word8 -> String
show_hex i = [cs !! (fromIntegral i `div` 16), cs !! (fromIntegral i `mod` 16)]
    where cs = "0123456789ABCDEF"

-- Is this exactly right?
make_key :: Hash -> Salt -> Count -> String -> (Integer, Int) -- (key, bits)
make_key MD5 s c p = (md5i $ Str $ take count $ cycle (s ++ p), 128)
    where count = shiftL (16 + (c .&. 15)) (shiftR c 4 + 6)
make_key SHA1 s c p = (sha1i $ take count $ cycle (s ++ p), 160)
    where count = shiftL (16 + (c .&. 15)) (shiftR c 4 + 6)
\end{code}

